classification
Title: Python should support VxWorks RTOS
Type: enhancement Stage: patch review
Components: Cross-Build Versions: Python 3.8
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: Nosy List: Alex.Willmer, Brian Kuhl, christian.heimes, izbyshev, lukasz.langa, ned.deily, pxinwr, r.david.murray, vstinner
Priority: normal Keywords: patch

Created on 2017-10-30 19:56 by Brian Kuhl, last changed 2019-05-30 08:04 by lzhao.

Pull Requests
URL Status Linked Edit
PR 4179 closed Brian Kuhl, 2017-10-30 20:46
PR 4184 closed Brian Kuhl, 2017-10-31 03:13
PR 11951 closed pxinwr, 2019-02-20 03:51
PR 11968 merged pxinwr, 2019-02-21 06:39
PR 12051 merged pxinwr, 2019-02-26 09:58
PR 12118 merged pxinwr, 2019-03-01 10:07
PR 12157 open pxinwr, 2019-03-04 08:45
PR 12304 merged pxinwr, 2019-03-13 07:26
PR 12305 merged pxinwr, 2019-03-13 09:43
PR 12319 closed ysun1, 2019-03-14 07:42
PR 12321 closed pxinwr, 2019-03-14 07:55
PR 12428 merged hliu0, 2019-03-19 09:25
PR 12646 merged lzhao, 2019-04-01 08:12
PR 12648 merged lzhao, 2019-04-01 09:48
PR 12670 open ysun1, 2019-04-03 02:33
PR 12719 merged lzhao, 2019-04-08 01:29
PR 12833 merged pxinwr, 2019-04-15 07:57
PR 13486 open hliu0, 2019-05-22 07:28
PR 13535 open hliu0, 2019-05-24 05:58
Messages (23)
msg305249 - (view) Author: Brian Kuhl (Brian Kuhl) * Date: 2017-10-30 19:56
With the trend to use REST APIs between the cloud and the IoT there is increasing interest in Python on embedded devices.  Cloud developer’s typical release a reference REST implementation of JSON and/or Python on Linux and leave it to the device developer to adapt it to their platform.   While many devices use eLinux, others with IP and/or hard real-time constraints need a commercial RTOS platform. 

Currently the automake configure explicitly prevents configuration of VxWorks as a build target.

I'll provide a pull request referencing this issue with the required changes.
msg305511 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2017-11-03 21:01
The following might be relevant to this issue:
https://www.python.org/dev/peps/pep-0011/#supporting-platforms
msg305657 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2017-11-06 16:55
To support a new platform, you need a developer who can support this platform next years, a working buildbot, etc. You can start a discussion on python-dev to get a first feedback.

Without a strong support, this issue should be fixed a REJECTED and a patch should be maintainted out of the tree. Since the PR seems small, it should be "easy" to keep a fork of CPython up to date.
msg305690 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2017-11-06 23:39
FYI I already started a thread on python-dev:
[Python-Dev] Partial support of a platform
https://mail.python.org/pipermail/python-dev/2017-November/150238.html
msg305869 - (view) Author: Brian Kuhl (Brian Kuhl) * Date: 2017-11-08 16:00
I'm quite happy to take on maintainer role for Python on VxWorks, so I think we can get that one solved. 

Enabling a build bot for cross compile of propitiatory OS presents a number of legal licensing issues that outside my control. And I'll discuss it internally at Wind River. However I think it is in line with where our customers want us to go, so well worth pursuing. 

I'll keep this pull request active and up to date, till the broader issues you have raised can be resolved.      

I'll post a proposal on the mailing list after I consulted within Wind River.

Many thanks for your interest and support.
msg305877 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2017-11-08 16:23
I'm not sure what licensing issues you are talking about, but setting up a buildbot shouldn't normally run into any.  As long as you have a license to the run the OS, the fact that you are using it to receive jobs from our build master and run them shouldn't be a problem.  You can keep the whole thing behind a firewall in a DMZ: the slave makes outbound connections to pick up its jobs.

On the other hand, the logistics of setting up a cross compile buildbot might be a bit complex, I've never done that.  You might need specific support from our build master.  In any case, the python-buldbots mailing list is the place to talk if you want to/can pursue this.
msg315365 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2018-04-16 19:40
As I commented on the PR, I think this PR should not be merged until and if there is a consensus that this support belongs in the standard cpython repo and there is an agreed-upon plan how this platform would be supported on going.  I think it needs an approved PEP.  We've allowed ourselves in the past to do a long-term disservice to our downstream users by merging in support for platforms that we were not equipped to support.  In any case, it would need to wait for 3.8.
msg336680 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-02-26 14:53
Kuhl, Brian started a new discussion: [Python-Dev] VxWorks and cpython?
https://mail.python.org/pipermail/python-dev/2019-January/156024.html

PR 11968 and PR 12051 are small and reasonable.

IMHO we can take decisions on a case by case basic. But WindRiver plans to provide a buildbot and is already showing their will to propose PRs, so it seems like things are moving on.
msg336742 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-02-27 11:09
New changeset 32f5fdd7f4213743fe2f6eedd0fe2108f3157021 by Victor Stinner (pxinwr) in branch 'master':
bpo-31904: Add cross-build support for VxWorks RTOS (GH-11968)
https://github.com/python/cpython/commit/32f5fdd7f4213743fe2f6eedd0fe2108f3157021
msg337083 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-03-04 09:02
New changeset f4b0a1c0da80318e0a4f4c70d2722f01ce3512dd by Victor Stinner (pxinwr) in branch 'master':
bpo-31904: Add encoding support for VxWorks RTOS (GH-12051)
https://github.com/python/cpython/commit/f4b0a1c0da80318e0a4f4c70d2722f01ce3512dd
msg337867 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-03-13 17:18
New changeset 8b5bdda5b4c418c4a858f183763d0a497170977c by Victor Stinner (pxinwr) in branch 'master':
bpo-31904: Adapt the _signal module to VxWorks RTOS (GH-12304)
https://github.com/python/cpython/commit/8b5bdda5b4c418c4a858f183763d0a497170977c
msg337909 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-03-14 10:28
Please stop to send new PRs which depend on other PRs which are not merged yet, it becomes too hard to follow :-( Let's focus on first PRs.
msg338964 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-03-27 15:11
New changeset f4333d0479d6974d142e858522e95cbf8381f016 by Victor Stinner (hliu0) in branch 'master':
bpo-31904: Fix test_utf8_mode on VxWorks (GH-12428)
https://github.com/python/cpython/commit/f4333d0479d6974d142e858522e95cbf8381f016
msg339059 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2019-03-28 16:47
I'm against implementing crypt on top of OpenSSL's DES_crypt. Please don't support the module at all instead of just supporting a completely broken implementation.
msg339898 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-04-10 23:36
Please stop adding more pull requests, I cannot review too many at the same time. I would prefer to have a limit of 4 open PRs. I don't propose to close existing ones. Just stop to add more :-)
msg340244 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-04-15 09:02
New changeset 236d0b75c41449a266201c683b4b0d6acdee02df by Victor Stinner (pxinwr) in branch 'master':
bpo-31904: Don't build the _crypt extension on VxWorks (GH-12833)
https://github.com/python/cpython/commit/236d0b75c41449a266201c683b4b0d6acdee02df
msg340245 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-04-15 09:06
New changeset f1464f4d2ecf9b809ff768c523c5eea1abd31c55 by Victor Stinner (pxinwr) in branch 'master':
bpo-31904: Port the time module on VxWorks (GH-12305)
https://github.com/python/cpython/commit/f1464f4d2ecf9b809ff768c523c5eea1abd31c55
msg340310 - (view) Author: Peixing Xin (pxinwr) * Date: 2019-04-16 03:37
@vstinner I've informed WRS team of temporarily not creating new PRs in until less than 4 PRs are in the open state. Next we will keep open PRs less than 4. Thanks for your effort on them.
msg340385 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-04-17 09:46
New changeset 36c41bc2017921321dbb19557f616a6bb7572c83 by Victor Stinner (Lihua Zhao) in branch 'master':
bpo-31904: Fix test_tabnanny on VxWorks (GH-12646)
https://github.com/python/cpython/commit/36c41bc2017921321dbb19557f616a6bb7572c83
msg340406 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-04-17 15:33
New changeset 2954550818e5c23a082e6279eb326168230ebf04 by Victor Stinner (Lihua Zhao) in branch 'master':
bpo-31904:  Port test_cmd_line to VxWorks (#12648)
https://github.com/python/cpython/commit/2954550818e5c23a082e6279eb326168230ebf04
msg340409 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-04-17 15:41
New changeset 693c104ae74feea11f0b51176dc91ecd153230c0 by Victor Stinner (Lihua Zhao) in branch 'master':
bpo-31904: Port test_resource to VxWorks (GH-12719)
https://github.com/python/cpython/commit/693c104ae74feea11f0b51176dc91ecd153230c0
msg343004 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-05-21 10:46
New changeset f2d7ac7e5bd821e29e0fcb78a760a282059ae000 by Victor Stinner (pxinwr) in branch 'master':
bpo-31904: Add posix module support for VxWorks (GH-12118)
https://github.com/python/cpython/commit/f2d7ac7e5bd821e29e0fcb78a760a282059ae000
msg343008 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-05-21 10:50
Please update PR 12670: see my comment there.
History
Date User Action Args
2019-05-30 08:04:35lzhaosetpull_requests: - pull_request12349
2019-05-24 05:58:59hliu0setpull_requests: + pull_request13449
2019-05-22 07:28:49hliu0setpull_requests: + pull_request13402
2019-05-21 10:50:53vstinnersetmessages: + msg343008
2019-05-21 10:46:40vstinnersetmessages: + msg343004
2019-04-17 15:41:37vstinnersetmessages: + msg340409
2019-04-17 15:33:43vstinnersetmessages: + msg340406
2019-04-17 09:46:54vstinnersetmessages: + msg340385
2019-04-16 03:37:50pxinwrsetmessages: + msg340310
2019-04-16 03:33:13pxinwrsetnosy: + pxinwr
2019-04-15 09:06:27vstinnersetmessages: + msg340245
2019-04-15 09:02:34vstinnersetmessages: + msg340244
2019-04-15 07:57:29pxinwrsetpull_requests: + pull_request12758
2019-04-10 23:36:47vstinnersetmessages: + msg339898
2019-04-08 01:29:37lzhaosetpull_requests: + pull_request12645
2019-04-03 02:33:56ysun1setpull_requests: + pull_request12598
2019-04-01 09:48:44lzhaosetpull_requests: + pull_request12580
2019-04-01 08:12:25lzhaosetpull_requests: + pull_request12578
2019-03-28 16:47:52christian.heimessetnosy: + christian.heimes
messages: + msg339059
2019-03-27 15:11:22vstinnersetmessages: + msg338964
2019-03-19 09:25:00hliu0setpull_requests: + pull_request12382
2019-03-18 06:33:02lzhaosetpull_requests: + pull_request12349
2019-03-14 10:28:02vstinnersetmessages: + msg337909
2019-03-14 07:55:27pxinwrsetpull_requests: + pull_request12295
2019-03-14 07:42:03ysun1setpull_requests: + pull_request12293
2019-03-13 19:01:26terry.reedysetnosy: - terry.reedy
2019-03-13 17:18:28vstinnersetmessages: + msg337867
2019-03-13 09:43:53pxinwrsetpull_requests: + pull_request12281
2019-03-13 07:26:37pxinwrsetpull_requests: + pull_request12280
2019-03-04 09:02:31vstinnersetmessages: + msg337083
2019-03-04 08:45:09pxinwrsetpull_requests: + pull_request12155
2019-03-02 16:59:16izbyshevsetnosy: + izbyshev
2019-03-01 10:07:22pxinwrsetpull_requests: + pull_request12123
2019-02-27 11:09:35vstinnersetmessages: + msg336742
2019-02-26 14:53:49vstinnersetmessages: + msg336680
2019-02-26 09:58:45pxinwrsetpull_requests: + pull_request12077
2019-02-21 06:39:38pxinwrsetpull_requests: + pull_request11994
2019-02-20 03:51:36pxinwrsetpull_requests: + pull_request11976
2018-04-16 19:40:29ned.deilysetnosy: + lukasz.langa, ned.deily

messages: + msg315365
versions: + Python 3.8, - Python 3.7
2017-11-08 16:23:25r.david.murraysetnosy: + r.david.murray
messages: + msg305877
2017-11-08 16:00:46Brian Kuhlsetmessages: + msg305869
2017-11-06 23:39:05vstinnersetmessages: + msg305690
2017-11-06 16:55:23vstinnersetnosy: + vstinner
messages: + msg305657
2017-11-03 21:01:04terry.reedysetnosy: + terry.reedy
messages: + msg305511
2017-10-31 03:13:38Brian Kuhlsetpull_requests: + pull_request4155
2017-10-30 20:46:47Brian Kuhlsetkeywords: + patch
stage: patch review
pull_requests: + pull_request4149
2017-10-30 19:56:33Brian Kuhlcreate